﻿using RobotSimulation.Neural_Network;
using RobotSimulation.RobotSimulation;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace RobotSimulation.Genetic
{
    public class Individual
    {
        public NeuralNetwork neuralNet;
        public double fitness = -9999;
        Random r = new Random();

        public Individual()
        {
            this.neuralNet = new NeuralNetwork();
            this.fitness = 0;
        }

        public Individual(NeuralNetwork nn)
        {
            this.neuralNet = nn;
            this.fitness = 0;
        }

        public NeuralNetwork mutateNeural()
        {
            NeuralNetwork mutant = new NeuralNetwork(this.neuralNet);
            for(int i = 0; i < mutant.weights.Length; i++)
            {
                int seed = (r.Next(10));
                if(seed == 9)
                {
                    mutant.weights[i] = mutant.weights[i] * 0.8;
                }
                else if(seed == 8)
                {
                    mutant.weights[i] = (mutant.weights[i] * 1.2) % 1;
                }
            }
            for (int i = 0; i < mutant.outputWeights.Length; i++)
            {
                int seed = (r.Next(10));
                if (seed == 9)
                {
                    mutant.weights[i] = mutant.weights[i] * 0.8;
                }
                else if (seed == 8)
                {
                    mutant.weights[i] = (mutant.weights[i] * 1.2) % 1;
                }
            }

            return mutant;
        }

        public string repr()
        {
            return "Individual: Fitness" + this.fitness + "Neural Weights: " + this.neuralNet.weights.ToString() +"Output Weigths: " + this.neuralNet.outputWeights.ToString();
        }



    }
}
