﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace RobotSimulation.RobotSimulation
{
    public class SimulationRoom
    {
        public RobotConfiguration rc;
        List<Line> lines = new List<Line>();
        int maxX = 100;
        int maxY = 100;
        int numlines = 5;
        Random r = new Random();

        public SimulationRoom()
        {
            double x = r.NextDouble() + r.Next(maxX - 1);
            double y = r.NextDouble() + r.Next(maxY - 1);
            for(int i = 0; i < numlines;i++)
            {
                Point first = new Point(x, y);
                x = r.NextDouble() + r.Next(maxX - 1);
                y = r.NextDouble() + r.Next(maxY - 1);
                Point second = new Point(x, y);
                lines.Add(new Line(first, second));
            }
            rc = new RobotConfiguration(lines[0].start.x, lines[0].start.y, lines[0].lineFacing());
        }



        public int sensorOverLine(int index)
        {
            Point sensor = this.rc.GetSensor(index);
            foreach(Line l in lines)
            {
                if (l.isPointOnLine(sensor))
                {
                    return 1;
                }
            }
            return 0;
        }

        public byte sense_line()
        {
            int prvy = sensorOverLine(1);
            int druhy = sensorOverLine(2);
            int treti = sensorOverLine(3);
            int stvrty = sensorOverLine(4);

            int vysl = prvy + druhy << 1 + treti << 2 + stvrty << 3;

            return (byte)vysl;
        }
    }
}
